(function($) {
	 'use strict';
	
	function dhwc_layout_init() {
		$(document).on('click','.dhvc-woo-quickview a',function(e){
			e.stopPropagation();
			e.preventDefault();
			var $this = $(this);
			$this.parent().addClass('loading');
			$.post(dhwc_layout_params.ajax_url,{
				action: 'dhvc_woo_product_quickview',
				product_id: $(this).data('product_id')
			},function(respon){
				$this.parent().removeClass('loading');
				var $modal = $(respon);
				$('body').append($modal);
				$( document.body ).trigger( 'dhvc_woo_before_show_modal', [ $modal, $this ] );
				
				$modal.on('hidden.dhmodal',function(){
					$modal.remove();
				});
				$modal.on('shown.dhmodal',function(){
					if('function'===typeof $.fn.wc_product_gallery){
						$modal.find('.woocommerce-product-gallery').wc_product_gallery();
					}
					
					if('function'===typeof $.fn.wc_variation_form){
						$modal.find('.variations_form').wc_variation_form();
					}
					
					$modal.find('.variations select').trigger('change');
				});
				
				$modal.dhmodal('show');
				
				$( document.body ).trigger( 'dhvc_woo_after_show_modal', [ $modal, $this ] );
			});
		});
		$(".dhvc-woo-ordering select").on('change',function(){
		    $(this).closest("form").submit();
		});
	
		$('.dhvc-woo-carousel-list').each(
				function() {
					var $this = $(this), defaults = {
						items : 4,
						pagination : false,
						singleItem : false,
						loop: true,
						dots:false,
						nav:false,
						navText: [],
						responsive:{
					        0:{
					            items:1
					        },
					        320:{
					            items:2
					        },
					        480:{
					            items:2
					        },
					        480:{
					            items:2
					        },
					        992:{
					            items:3
					        },
					        1000:{
					            items:5
					        }
					    }
					}, options = $.extend({}, defaults, {
						items : $this.data('items'),
						responsive:{
					        0:{
					            items:1,
					            dots:true,
					        },
					        320:{
					        	items: $this.data('breakpoint-320-item'),
					            dots:true
					        },
					        480:{
					            items: $this.data('breakpoint-480-item'),
					            dots:true
					        },
					        768:{
					        	items:$this.data('breakpoint-768-item'),
					            dots:true
					        },
					        992:{
					            items:$this.data('breakpoint-992-item'),
					            dots:true
					        },
					        1000:{
					            items:$this.data('items')
					        }
					    },
					    margin: $this.data('item_margin'),
					    dots:$this.data('pagination'),
					    autoplay: $this.data('carousel_autoplay'),
						autoplayTimeout: $this.data('carousel_autoplay_timeout'),
						autoplayHoverPause: true,
						pagination : $this.data('pagination'),
						nav: $this.data('nav')
					});
	
					$this.owlCarousel(options);
					$this.closest('.dhvc-woo').find('.dhvc-woo-carousel-prev')
							.on('click',function(e) {
								e.stopPropagation();
								e.preventDefault();
								$this.data('owlCarousel').prev();
							});
					$this.closest('.dhvc-woo').find('.dhvc-woo-carousel-next')
							.on('click',function(e) {
								e.stopPropagation();
								e.preventDefault();
								$this.data('owlCarousel').next();
							});
		});
		
		var getIsotopeOptions = function($container){
			var orderby = $container.data('orderby'),
				order = $container.data('order'),
				isotopeOptions = {
					itemSelector : '.dhvc-woo-masonry-item-selector',
					transitionDuration : '0.8s',
					percentPosition: true,
					masonry : {
						gutter : $container.data('masonry-gutter'),
						horizontalOrder: true
					},
					getSortData: {
						date: '[data-date]',
						modified: '[data-modified]',
					}
				}
			
			if(orderby === 'date' || orderby === 'modified'){
				isotopeOptions['sortBy'] = orderby;
				if('ASC' !== order){
					isotopeOptions['sortAscending'] = false;
				}
				
			}
			return isotopeOptions;
		}
		
		$('.dhvc-woo-masonry-list').each(function() {
			var $this = $(this);
			
			$this.isotope(getIsotopeOptions($this));
			
			window.setTimeout(function(){
				$this.isotope('layout');
			},2000);
		});
	
		$(document).on('click','.dhvc-woo-filter',function(e) {
	
			e.stopPropagation();
			e.preventDefault();
	
			var $this = $(this), $container = $this.closest('.dhvc-woo').find('.dhvc-woo-masonry-list');
			
			// don't proceed if already selected
			if ($this.hasClass('selected')) {
				return false;
			}
			var filters = $this.closest('ul');
			filters.find('.selected').removeClass('selected');
			$this.addClass('selected');
	
			var options = getIsotopeOptions($container), 
				key = filters.attr('data-option-key'), 
				value = $this.attr('data-option-value');
	
			value = value === 'false' ? false : value;
			options[key] = value;
	
			$container.isotope(options);
		});
	
	}
	
	$(document).ready(function($) {
		dhwc_layout_init();
		$('body').on( 'added_to_cart',function(){
			if(window.fragments){
				$('.dhvc-woo-masonry-list').each(function() {
					var $this = $(this);
					$this.isotope('layout');
				});
			}
		});
	});
})(window.jQuery);

