<?php

class DHWC_Layout_Vc {
	public function __construct(){
		add_action('vc_load_default_params', array($this,'add_params'));
		add_action( 'vc_after_set_mode', array($this,'map_shortcode'), 20);
		
		//add_action('vc_admin_inline_editor',array($this,'enqueue_iniline_script'));
		
		add_action( 'vc_after_mapping', array($this,'after_mapping') );
		
	}
	
	public function add_params(){
		vc_add_shortcode_param ( 'dhwc_layout_field_id', 'dhwc_layout_param_field_id');
		vc_add_shortcode_param ( 'dhwc_layout_field_attributes', 'dhwc_layout_param_field_attributes');
		vc_add_shortcode_param ( 'dhwc_layout_field_heading', 'dhwc_layout_param_field_heading',DHVC_WOO_URL.'/assets/js/params.js');
		
	}
	
	public function after_mapping(){
		//For suggestion: vc_autocomplete_[shortcode_name]_[param_name]_callback
		add_filter( 'vc_autocomplete_dhvc_woo_products_products_callback', array(
			$this,
			'productsAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_products_render', array(
			$this,
			'productsAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_products_callback', array(
			$this,
			'productsAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_products_render', array(
			$this,
			'productsAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_category_callback', array(
			$this,
			'productCategoryAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_category_render', array(
			$this,
			'productCategoryAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_category_callback', array(
			$this,
			'productCategoryAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_category_render', array(
			$this,
			'productCategoryAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_brand_callback', array(
			$this,
			'productBrandAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_brand_render', array(
			$this,
			'productBrandAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_brand_callback', array(
			$this,
			'productBrandAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_brand_render', array(
			$this,
			'productBrandAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_tag_callback', array(
			$this,
			'productTagAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_tag_render', array(
			$this,
			'productTagAutocompleteRender',
		), 10, 1 );
		
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_tag_callback', array(
			$this,
			'productTagAutocompleteSuggester',
		), 10, 1 );
		add_filter( 'vc_autocomplete_dhvc_woo_products_exclude_tag_render', array(
			$this,
			'productTagAutocompleteRender',
		), 10, 1 );
	}
	
	public function productTagAutocompleteSuggester($query){
		return $this->_productTermAutocompleteSuggester($query,'product_tag');
	}
	
	public function productTagAutocompleteRender($query){
		return $this->_productTermAutocompleteRender($query,'product_tag');
	}
	
	public function productBrandAutocompleteSuggester($query){
		return $this->_productTermAutocompleteSuggester($query,'product_brand');
	}
	
	public function productBrandAutocompleteRender($query){
		return $this->_productTermAutocompleteRender($query,'product_brand');
	}
	
	public function productCategoryAutocompleteSuggester($query){
		return $this->_productTermAutocompleteSuggester($query);
	}
	
	public function productCategoryAutocompleteRender($query){
		return $this->_productTermAutocompleteRender($query);
	}
	
	protected function _productTermAutocompleteSuggester($query, $term = 'product_cat'){
		global $wpdb;
		$term_id = (int) $query;
		$query = trim( $query );
		$post_meta_infos = $wpdb->get_results( $wpdb->prepare( "SELECT a.term_id AS id, b.name as name, b.slug AS slug
						FROM {$wpdb->term_taxonomy} AS a
						INNER JOIN {$wpdb->terms} AS b ON b.term_id = a.term_id
						WHERE a.taxonomy = '".$term."' AND (a.term_id = '%d' OR b.slug LIKE '%%%s%%' OR b.name LIKE '%%%s%%' )", $term_id > 0 ? $term_id : - 1, stripslashes( $query ), stripslashes( $query ) ), ARRAY_A );
		
		$result = array();
		if ( is_array( $post_meta_infos ) && ! empty( $post_meta_infos ) ) {
			foreach ( $post_meta_infos as $value ) {
				$data = array();
				$data['value'] = $value['id'];
				$data['label'] = esc_html__( 'Id', DHVC_WOO ) . ': ' . $value['id'] . ( ( strlen( $value['name'] ) > 0 ) ? ' - ' . esc_html__( 'Name', DHVC_WOO ) . ': ' . $value['name'] : '' ) . ( ( strlen( $value['slug'] ) > 0 ) ? ' - ' . esc_html__( 'Slug', DHVC_WOO ) . ': ' . $value['slug'] : '' );
				$result[] = $data;
			}
		}
		
		return $result;
	}
	
	protected function _productTermAutocompleteRender( $query, $term =  'product_cat') {
		$query = $query['value'];
		$cat_id = (int) $query;
		$term = get_term( $cat_id, 'product_cat' );
		if(empty($term) || is_wp_error($term)){
			return false;
		}
		$term_slug = $term->slug;
		$term_title = $term->name;
		$term_id = $term->term_id;
		
		$term_slug_display = '';
		if ( ! empty( $term_slug ) ) {
			$term_slug_display = ' - ' . esc_html__( 'Sku', DHVC_WOO ) . ': ' . $term_slug;
		}
		
		$term_title_display = '';
		if ( ! empty( $term_title ) ) {
			$term_title_display = ' - ' . esc_html__( 'Title', DHVC_WOO ) . ': ' . $term_title;
		}
		
		$term_id_display = esc_html__( 'Id', DHVC_WOO ) . ': ' . $term_id;
		
		$data = array();
		$data['value'] = $term_id;
		$data['label'] = $term_id_display . $term_title_display . $term_slug_display;
		
		return ! empty( $data ) ? $data : false;
	}
	
	public function productsAutocompleteSuggester($query ){
		global $wpdb;
		$product_id = (int) $query;
		$post_meta_infos = $wpdb->get_results( $wpdb->prepare( "SELECT a.ID AS id, a.post_title AS title, b.meta_value AS sku
					FROM {$wpdb->posts} AS a
					LEFT JOIN ( SELECT meta_value, post_id  FROM {$wpdb->postmeta} WHERE `meta_key` = '_sku' ) AS b ON b.post_id = a.ID
					WHERE a.post_type = 'product' AND ( a.ID = '%d' OR b.meta_value LIKE '%%%s%%' OR a.post_title LIKE '%%%s%%' )", $product_id > 0 ? $product_id : - 1, stripslashes( $query ), stripslashes( $query ) ), ARRAY_A );
		
		$results = array();
		if ( is_array( $post_meta_infos ) && ! empty( $post_meta_infos ) ) {
			foreach ( $post_meta_infos as $value ) {
				$data = array();
				$data['value'] = $value['id'];
				$data['label'] = esc_html__( 'Id', DHVC_WOO ) . ': ' . $value['id'] . ( ( strlen( $value['title'] ) > 0 ) ? ' - ' . esc_html__( 'Title', DHVC_WOO ) . ': ' . $value['title'] : '' ) . ( ( strlen( $value['sku'] ) > 0 ) ? ' - ' . esc_html__( 'Sku', DHVC_WOO ) . ': ' . $value['sku'] : '' );
				$results[] = $data;
			}
		}
		
		return $results;
	}
	
	public function productsAutocompleteRender($query){
		$query = trim( $query['value'] ); // get value from requested
		if ( ! empty( $query ) ) {
			// get product
			$product_object = wc_get_product( (int) $query );
			if ( is_object( $product_object ) ) {
				$product_sku = $product_object->get_sku();
				$product_title = $product_object->get_title();
				$product_id = $product_object->get_id();
				
				$product_sku_display = '';
				if ( ! empty( $product_sku ) ) {
					$product_sku_display = ' - ' . esc_html__( 'Sku', DHVC_WOO ) . ': ' . $product_sku;
				}
				
				$product_title_display = '';
				if ( ! empty( $product_title ) ) {
					$product_title_display = ' - ' . esc_html__( 'Title',DHVC_WOO ) . ': ' . $product_title;
				}
				
				$product_id_display = esc_html__( 'Id', DHVC_WOO ) . ': ' . $product_id;
				
				$data = array();
				$data['value'] = $product_id;
				$data['label'] = $product_id_display . $product_title_display . $product_sku_display;
				
				return ! empty( $data ) ? $data : false;
			}
			
			return false;
		}
		
		return false;
	}
	
	public function map_shortcode(){
		$params = dhwc_layout_get_setting_params();
		$params[] = array(
			'type' 			=> 'css_editor',
			'heading' 		=> __( 'CSS box', DHVC_WOO ),
			'param_name' 	=> 'css',
			'group' 		=> __( 'Design Options', DHVC_WOO ),
		);
		vc_map ( array (
			'name' 			=> __ ( 'WC Products Layout', DHVC_WOO ),
			'base' 			=> 'dhvc_woo_products',
			'category' 		=> __ ( 'DHWC Layout', DHVC_WOO ),
			'icon' 			=> 'dhwc-layout-icon',
			'params' 		=> $params
		) );
	}
	
	public function enqueue_iniline_script(){
		wp_enqueue_script('dhwc-layout-iniline',DHVC_WOO_URL.'/assets/js/iniline.js',array(),DHVC_WOO_VERSION,true);
	}
}

new DHWC_Layout_Vc();