<?php

class DHWC_Brand_Shortcode_Products extends WC_Shortcode_Products {
    
    /**
     * 
     * {@inheritDoc}
     * @see WC_Shortcode_Products::parse_attributes()
     */
    protected function parse_attributes($attributes){
        $parsed_attributes = parent::parse_attributes($attributes);
        $parsed_attributes['brand'] = isset($attributes['brand']) ? $attributes['brand'] : '';
        $parsed_attributes['brand_operator'] = isset($attributes['brand_operator']) ? $attributes['brand_operator'] : 'IN';
        return $parsed_attributes;
    }
    
    /**
     * 
     * @param array $query_args
     */
    public function set_brand_products_query_args( &$query_args){
        if ( ! empty( $this->attributes['brand'] ) ) {
            $brand_operator = isset($this->attributes['brand_operator']) ? $this->attributes['brand_operator'] : 'IN';
           
            $brands = array_map( 'sanitize_title', explode( ',', $this->attributes['brand'] ) );
            $field      = 'slug';
            
            if ( is_numeric( $brands[0] ) ) {
                $field      = 'term_id';
                $brands = array_map( 'absint', $brands );
                // Check numeric slugs.
                foreach ( $brands as $brand ) {
                    $the_brand = get_term_by( 'slug', $brand, 'product_brand' );
                    if ( false !== $the_brand ) {
                        $brands[] = $the_brand->term_id;
                    }
                }
            }
            
            $query_args['tax_query'][] = array(
                'taxonomy'         => 'product_brand',
                'terms'            => $brands,
                'field'            => $field,
                'operator'         => $brand_operator,
                
                /*
                 * When brand_operator is AND, the children brands should be excluded,
                 * as only products belonging to all the children brands would be selected.
                 */
                'include_children' => 'AND' === $brand_operator ? false : true,
            );
        }
    }
}