<?php 
/**
 * The Template for displaying product image
 *
 * Override this template by copying it to yourtheme/dhvc-woocommerce/parts/image.php
 */
/**
 * @var WC_Product $product;
 */
global $product;

$inline_style = '';
if('list'===$atts['display']){
	$box_thumbnail_width = absint($atts['box_thumbnail_width']);
	if(empty($box_thumbnail_width)){
		$box_thumbnail_width = absint($atts['thumbnail_width']);
	}
	if(!$box_thumbnail_width){
		$shop_single_size  = wc_get_image_size('shop_catalog');
		$box_thumbnail_width = absint($shop_single_size['width']);
	}
	$inline_style = ' style="flex:0 0 '.$box_thumbnail_width.'px;-webkit-flex:0 0 '.$box_thumbnail_width.'px;-ms-flex:0 0 '.$box_thumbnail_width.'px;width:'.$box_thumbnail_width.'px"';
}
?>
<div class="dhvc-woo-images"<?php echo $inline_style?>>
	<?php 
	
	do_action('dhwc_layout_before_product_image');
	
	if('yes'===$atts['show_quickview']):
		wp_enqueue_script('dhwc-layout-modal');
		wp_enqueue_style('dhwc-layout-modal');
		
		wp_enqueue_script('wc-single-product');
		wp_enqueue_script('wc-add-to-cart-variation');
		
		if ( current_theme_supports( 'wc-product-gallery-slider' ) ) {
			wp_enqueue_script( 'flexslider' );
		}
		?>
		<div class="dhvc-woo-quickview">
			<a data-product_id="<?php echo get_the_ID()?>" href="#"><?php echo __('Quick view',DHVC_WOO)?></a>
		</div>
	<?php endif;?>
	
	<?php 
	
	if(defined('YITH_WCWL')){
		echo do_shortcode('[yith_wcwl_add_to_wishlist]'); 
	}
	
	if($product->is_in_stock()){
	    if('yes' !== $atts['hide_sale_flash'] && $product->is_on_sale()){
	        woocommerce_show_product_sale_flash();
	    }
	}else{
	    if('yes'===$atts['show_out_of_stock_flash']){
	        ?>
	        <span class="onsale out-of-stock"><?php echo esc_html($atts['out_of_stock_text'])?></span>
	        <?php 
	    }
	}
	?>
	
	<a href="<?php echo get_permalink ()?>">
	
	<?php 
	if(has_post_thumbnail()):
		$thumb_size = 'shop_catalog';
		if(!empty($atts['thumbnail_height']) && !empty($atts['thumbnail_width'])){
			$thumb_size = $atts['thumbnail_width'].'x'.$atts['thumbnail_height'];
			$thumbnail_data = dhwc_layout_get_image_by_size(array( 'post_id' => $product->get_id(), 'thumb_size' => $thumb_size ));
			$thumbnail_image = $thumbnail_data['thumbnail'];
		}else{
			$thumbnail_image = get_the_post_thumbnail( $product->get_id(), $thumb_size );
		}
		
		if('yes'===$atts['hover_thumbnail']){
			echo dhwc_layout_get_product_thumbnail($product, $thumb_size);
			echo dhwc_layout_get_product_frist_thumbnail($product, $thumb_size);
		} else{
			echo $thumbnail_image;
		}
	else:
		echo sprintf( '<img src="%s" alt="%s" />', esc_url( wc_placeholder_img_src( 'woocommerce_single' ) ), esc_html__( 'Awaiting product image', DHVC_WOO ) );
	endif;
	
	?>
	</a>
	
	<?php do_action('dhwc_layout_after_product_image')?>
</div>