<?php
/**
 * The Template for displaying pagination
 *
 * Override this template by copying it to yourtheme/dhvc-woocommerce/parts/pagination.php
 */
$total   = isset( $total ) ? $total : wc_get_loop_prop( 'total_pages' );
$current = isset( $current ) ? $current : wc_get_loop_prop( 'current_page' );
$base    = isset( $base ) ? $base : esc_url_raw( str_replace( 999999999, '%#%', remove_query_arg( 'add-to-cart', get_pagenum_link( 999999999, false ) ) ) );
$format  = isset( $format ) ? $format : '';

if ( $total <= 1 || 'yes' === $atts['hide_grid_pagination'] ) {
	return;
}
?>
<div class="pagination dhvc-woo-pagination">
	<?php 
	echo paginate_links( apply_filters( 'dhvc_woo_pagination_args', array( // WPCS: XSS ok.
		'base'          => $base,
		'format'        => $format,
		'add_args'      => false,
		'current'       => max( 1, $current ),
		'total'         => $total,
		'prev_text'     => '&larr;',
		'next_text'    	=> '&rarr;',
		'type'         	=> 'plain',
		'end_size'     	=> 3,
		'mid_size'    	=> 3,
	) ) );
	?>
</div>