<?php
/**
 * The Template for displaying result count
 *
 * Override this template by copying it to yourtheme/dhvc-woocommerce/parts/result-count.php
 */

$total = wc_get_loop_prop( 'total' );
$per_page = wc_get_loop_prop( 'per_page' );
$current = wc_get_loop_prop( 'current_page' );
?>
<p class="dhvc-woo-result-count">
	<?php 
	if ( $total <= $per_page || -1 === $per_page ) {
		/* translators: %d: total results */
		printf( _n( 'Showing the single result', 'Showing all %d results', $total, DHVC_WOO ), $total );
	} else {
		$first = ( $per_page * $current ) - $per_page + 1;
		$last  = min( $total, $per_page * $current );
		/* translators: 1: first result 2: last result 3: total results */
		printf( _nx( 'Showing the single result', 'Showing %1$d&ndash;%2$d of %3$d results', $total, 'with first and last result', DHVC_WOO ), $first, $last, $total );
	}
	?>
</p>